// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// GraySearchDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "GraySearch.h"
#include "GraySearchDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraySearchDlg _CAO

CGraySearchDlg::CGraySearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGraySearchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGraySearchDlg)
	m_searchmode = -1;
	m_precision = -1;
	m_condition = 5;
	m_threshold = 60;
	m_middlethreshold = 50;
	m_searchnum = 1;
	m_wndtouch = FALSE;
	m_result = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGraySearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGraySearchDlg)
	DDX_CBIndex(pDX, IDC_SEARCHMODE, m_searchmode);
	DDX_CBIndex(pDX, IDC_PRECISION, m_precision);
	DDX_Text(pDX, IDC_CONDITION, m_condition);
	DDV_MinMaxInt(pDX, m_condition, 1, 9);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxInt(pDX, m_threshold, 10, 99);
	DDX_Text(pDX, IDC_MIDDLETHRESHOLD, m_middlethreshold);
	DDV_MinMaxInt(pDX, m_middlethreshold, 10, 99);
	DDX_Text(pDX, IDC_SEARCHNUM, m_searchnum);
	DDV_MinMaxInt(pDX, m_searchnum, 1, 9999999);
	DDX_Check(pDX, IDC_WNDTOUCH, m_wndtouch);
	DDX_Text(pDX, IDC_RESULT, m_result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGraySearchDlg, CDialog)
	//{{AFX_MSG_MAP(CGraySearchDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_BN_CLICKED(IDC_SETPATTERN, OnSetpattern)
	ON_BN_CLICKED(IDC_SETPATTERNMASK, OnSetpatternmask)
	ON_BN_CLICKED(IDC_DISPPATTERN, OnDisppattern)
	ON_BN_CLICKED(IDC_LOADPATTERN, OnLoadpattern)
	ON_BN_CLICKED(IDC_SAVEPATTERN, OnSavepattern)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraySearchDlg bZ[W nh

BOOL CGraySearchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){
		long err_no ;

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		CWnd *pwnd ;
		IUnknown *p_unknown;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );
	
		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxROI1.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxROI2.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxCorrelation.CreateInstance( __uuidof( FvxCorrelation ) ); 
		m_FvxPattern.CreateInstance( __uuidof( FvxPattern ) ); 
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 

		// J荞ݖ
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );
		m_blnVideoOpened = false;

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putye( -1 );

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_SEARCHMODE );
		pcmb->AddString( "ʏ̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "sp^[" );
		m_searchmode = 0 ;

		pcmb = ( CComboBox* )GetDlgItem( IDC_PRECISION );
		pcmb->AddString( "ʏ퐸x" );
		pcmb->AddString( "x" );
		pcmb->AddString( "x" );
		m_precision = 2 ;
		
		UpdateData(FALSE); 
		
		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {

			// rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImage );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImage );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	UpdateData(FALSE); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
	
}

void CGraySearchDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CGraySearchDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CGraySearchDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// EBhETCY̕ύX
void CGraySearchDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}

// ʃN[Y
void CGraySearchDlg::OnDestroy() 
{
	CDialog::OnDestroy();

    if ( m_blnVideoOpened == true ) {
        // rfIfoCXI[vĂꍇ̓N[Y܂
        m_FvxVideo->CloseDevice();
	}
		
}

BOOL CGraySearchDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}	
	return CDialog::PreTranslateMessage(pMsg);
}

// 摜t@CǍ
void CGraySearchDlg::OnLoadimage() 
{
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t(cFileDlg.GetPathName()) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜`FbN
		if (( m_FvxImage->GetBitPerPixel()!=8 ) || ( m_FvxImage->GetImageType ()!=imageGray )){

			MessageBox("8bitO[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage->PutBitPerPixel( 8 );
            m_FvxImage->PutImageType( imageGray );
            m_FvxImage->PutImageWidth( 512 );
            m_FvxImage->PutImageHeight( 480 );

		}

		m_FvxDisplayEx->DrawImage( m_FvxImage );
	}
}

// 摜t@Cۑ
void CGraySearchDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// ͈͂̐ݒ
void CGraySearchDlg::OnExeregion() 
{
    long lngOK = 0;
    double dblTemp = 0;
    
    m_FvxROI1->SetRectangle( m_ExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI1->PutUsePoint( FALSE );
    m_FvxROI1->MakeROIDialog( m_FvxImage, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI1->GetCheckRectangle() == 1 ) ) {
        m_FvxROI1->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs() ) {
            dblTemp = m_ExeRegion->Getxs();
            m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys() ) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}
}

// p^[o^
void CGraySearchDlg::OnSetpattern() 
{

    IFvRectangle2Ptr pRect(__uuidof( FvRectangle ));  // p^[̈̐ݒ
    IFvPointPtr pPoint(__uuidof( FvPoint ));		  // p^[_

    long lngOK = 0;
    double dblTemp = 0;
    
    // o^̏`ݒ
    pRect->Putxs( 100 );
    pRect->Putys( 100 );
    pRect->Putxe( 200 );
    pRect->Putye( 200 );
    m_FvxROI2->SetRectangle( pRect );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI2->MakeROIDialog( m_FvxImage, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI2->GetCheckRectangle() == 1 )) {
        m_FvxROI2->GetRectangle( pRect );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( pRect->Getxe() < pRect->Getxs() ) {
            dblTemp = pRect->Getxs();
            pRect->Putxs( pRect->Getxe() );
            pRect->Putxe( dblTemp );
		}
		if ( pRect->Getye() < pRect->Getys() ) {
            dblTemp = pRect->Getys();
            pRect->Putys( pRect->Getye());
            pRect->Putye( dblTemp );
		}
			
        if ( m_FvxROI2->GetCheckPoint() == 1 ) {
            m_FvxROI2->GetPoint( pPoint );
		} else {
			MessageBox("p^[_w肳܂łB\r\np^[`̒S_Ƃēo^܂","p^[o^", MB_ICONWARNING | MB_OK);
            pPoint->Putx( (pRect->Getxs() + pRect->Getxe()) / (double)2 );
            pPoint->Puty( (pRect->Getys() + pRect->Getye()) / (double)2 );
		}
        m_FvxPattern->MakePattern( m_FvxImage, pRect, pPoint );
	}
}

// p^[̃}XNݒ
void CGraySearchDlg::OnSetpatternmask() 
{
    m_FvxPattern->DefMask(-1 , -1);
}

// p^[̕\
void CGraySearchDlg::OnDisppattern()
{
    m_FvxPattern->Disp(-1 , -1);
}

// p^[t@C̓Ǎ
void CGraySearchDlg::OnLoadpattern() 
{

    // p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
    //  "pat"gp邱Ƃ𐄏܂
	char szFilters[]="pat file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
        
		try {
			m_FvxPattern->PutLoadPattrenFileName( _bstr_t(cFileDlg.GetPathName()));
			m_FvxPattern->Load();
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("p^[Ǎݎs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}	
}

// p^[t@C̕ۑ
void CGraySearchDlg::OnSavepattern() 
{

	char szFilters[]="pat file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			m_FvxPattern->PutSavePattrenFileName( _bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern->Save();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern->GetErrReport( &lngErr );
			cStr.Format("p^[ۑsBerr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// J摜荞
void CGraySearchDlg::OnGrab() 
{
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage );

    // 捞
    m_FvxVideo->GrabSync( m_FvxImage );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage );
}

// s{^
void CGraySearchDlg::OnExecute() 
{

    IFvSearchResultGroup2Ptr pSearchResultGroup(__uuidof(FvSearchResultGroup));
    IFvPointPtr pPoint(__uuidof(FvPoint));

	if ( !UpdateData(TRUE) ) return;
    
	m_FvxDisplayEx->ClearOverlay( -1 );

	try {
	
		// p[^ݒ
		m_FvxCorrelation->SetInspectArea( m_ExeRegion );						// ͈
		m_FvxCorrelation->PutSearchMode( ( SEARCH_MODE_TYPE )m_searchmode );	// T[`[hiׂȂǂ̃p^[Ɏgpj
		m_FvxCorrelation->PutPrecision( ( PRECISION_TYPE )m_precision );		// T[`
    
		// 摜̏
		if ( ( m_condition < 1 ) || ( m_condition > 9 )) {
			MessageBox("摜Ԃ 1`9 ̊ԂŐݒ肵Ă" , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
		m_FvxCorrelation->PutCondition( m_condition );
    
		// 臒l
		if ( ( m_threshold < 10 ) ||  ( m_threshold  > 1000 ) ) {
			MessageBox("臒l 10`100 ̊Ԃœ͂Ă" , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
		m_FvxCorrelation->PutScoreThresh( m_threshold );
    
		// r臒l
		if ( ( m_middlethreshold < 10 ) || ( m_middlethreshold > 1000 ) ) {
			MessageBox("r臒l 10`100 ̊Ԃœ͂Ă" , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
		m_FvxCorrelation->PutScoreThresh2( m_middlethreshold );
    
		// T[`
		m_FvxCorrelation->PutSearchNum( m_searchnum );
    
		// ͈͐ڐGĂ̂o邩
		if ( m_wndtouch == TRUE  ) {
			m_FvxCorrelation->PutWindowTouch( (WINDOW_TOUCH_TYPE)1 );
		} else {
			m_FvxCorrelation->PutWindowTouch( (WINDOW_TOUCH_TYPE)0 );
		}

		// ----------------------------------------------------------------
		// ԌvJn
		m_FvxPerformanceCounter->StartCount();
    
		// p^[ݒ
		m_FvxCorrelation->SetPattern( m_FvxPattern );
    
		// T[`s
		long lngCount = 0;
		m_FvxCorrelation->Execute( m_FvxImage, &lngCount );
		// ----------------------------------------------------------------

		// ԌvI
		double dblTime = 0;
		m_FvxPerformanceCounter->StopCount( &dblTime );
    
		// ͈͂ŕ\
		m_FvxDisplayEx->PutPenColor(RGB(0, 0, 255));
		m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
    
		// T[`ʂԂŕ\
		m_FvxDisplayEx->PutPenColor(RGB(255, 0, 0));
		m_FvxDisplayEx->PutFontColor(RGB(0, 0, 255));

		m_result.Format(" : %.2fms\r\n\r\nT[` : %d\r\nNo      X      Y   score\r\n" , dblTime , lngCount );
    
		m_FvxCorrelation->GetResult( 0, pSearchResultGroup );
		m_FvxDisplayEx->DrawData( 0, pSearchResultGroup );
    
		CString szStr;
		for ( int i = 0; i < pSearchResultGroup->GetCount(); i++ ) {
			pPoint->Putx( pSearchResultGroup->Item2(i)->Getx() );
			pPoint->Puty( pSearchResultGroup->Item2(i)->Gety() );
			szStr.Format("%d",i);
			m_FvxDisplayEx->DrawText( 0, pPoint, _bstr_t( szStr ));
			szStr.Format("%3d  %3.1f  %3.1f   %3d\r\n",i,pSearchResultGroup->Item2(i)->Getx(),pSearchResultGroup->Item2(i)->Gety(),pSearchResultGroup->Item2(i)->Getscore() );
			m_result = m_result + szStr;
		}

		UpdateData( FALSE );

	} catch ( _com_error ) {
	    
		long lngErr = 0;
		CString szStr;
		m_FvxCorrelation->GetErrReport( &lngErr );

		switch (lngErr) {
			case 0:
				szStr = "G[";
				break;
			case 5001:
				szStr = "p^݂Ă܂B";
				break;
			case 5005:
				szStr = "p[^Ⴂ܂B";
				break;
			case 5006:
				szStr = "^Ⴂ܂B";
				break;
			case 5007:
				szStr = "p^摜̂߁Ao^ł܂B";
				break;
			case 5008:
				szStr = "p^ƃ}XÑTCYvĂ܂B";
				break;
			case 5009:
				szStr = "p[^NULLlw肳܂B";
				break;
			case 5010:
				szStr = "̊mۂɎs܂B";
				break;
			case 5022:
				szStr = "p^w肳Ă܂B";
				break;
			default:
				szStr = "sȃG[";
				break;
		}
		MessageBox(szStr , "G[", MB_ICONWARNING | MB_OK);
    }
}
